Bug 479413 - Review Request: pywebdav - WebDAV library for Python
Review Request: pywebdav - WebDAV library for Python
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Ignacio Vazquez-Abrams
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-01-09 08:33 EST by Dan Horák
Modified: 2009-01-21 03:18 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-01-21 03:18:44 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
ivazqueznet: fedora‑review+
kevin: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Dan Horák 2009-01-09 08:33:15 EST
Spec URL: http://fedora.danny.cz/pywebdav.spec
SRPM URL: http://fedora.danny.cz/pywebdav-0.8-1.fc11.src.rpm

Description:
WebDAV library for Python. WebDAV is an extension to the normal HTTP/1.1
protocol allowing the user to upload data, create collections of objects,
store properties for objects, etc.
Comment 1 David Carter 2009-01-10 09:38:09 EST
Hi, I'm not an approved reviewer yet, and am doing this as a practice review. So while I'm making every effort to make this as complete and accurate a review as possible, this can't be considered a final review.

MUST: rpmlint must be run on every package. The output should be posted in the review.

rpmlint -i pywebdav-0.8-1.fc11.src.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
rpmlint -i pywebdav-0.8-1.fc9.noarch.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

OK.

MUST: The package must be named according to the Package Naming Guidelines

According to the naming guidelines, this fits into the python exception for upstream packages starting with py, so

OK.

MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.

OK

MUST: The package must meet the Packaging Guidelines

OK, including python specific guidelines

MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines

OK.

MUST: The License field in the package spec file must match the actual license.

OK.

MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.

OK.

MUST: The spec file must be written in American English.

OK.

MUST: The spec file for the package MUST be legible.

OK.

MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.

OK

MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.

OK. x86_64

MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.

N/A

MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.

OK.

MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.

N/A.

MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.

N/A

MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.

N/A.

MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.

OK.

MUST: A package must not contain any duplicate files in the %files listing.

OK.

MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line. [14]

OK.

MUST: Each package must have a %clean section, which contains rm -rf %{buildroot} (or $RPM_BUILD_ROOT).

OK.

MUST: Each package must consistently use macros.

Not really. For example, consider the line
%{__python} setup.py install -O1 --skip-build --root $RPM_BUILD_ROOT
Which should be:
%{__python} setup.py install -O1 --skip-build --root %{buildroot}

even though the first is given as an example in the documentation.


MUST: The package must contain code, or permissable content.

OK.

MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity).

OK.

MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.

OK.

MUST: Header files must be in a -devel package.

OK.

MUST: Static libraries must be in a -static package.

OK.

MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for directory ownership and usability).

OK.

MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package.

OK.

MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release}

OK.

MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.

OK.

MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.

OK.

MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time. [24]

OK.

MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot} (or $RPM_BUILD_ROOT).

OK.

MUST: All filenames in rpm packages must be valid UTF-8.

OK.



SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.

OK.

SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.

OK.

SHOULD: The reviewer should test that the package builds in mock.

OK.

SHOULD: The package should compile and build into binary rpms on all supported architectures.

Unable to test on non-x86(_64) platforms

SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.

OK.

SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.

OK.

SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.

OK.

SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb.

OK.

SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.

OK.

Summary - MINOR issues with use of macros in spec file.

I am curious though as to why the example server isn't included in either the same package, or in a documentation package. I would expect to see it in /usr/share/pywebdav-0.8. I really think this would be a worthwhile addition.
Comment 2 Dan Horák 2009-01-10 10:10:57 EST
(In reply to comment #1)
> MUST: Each package must consistently use macros.
> 
> Not really. For example, consider the line
> %{__python} setup.py install -O1 --skip-build --root $RPM_BUILD_ROOT
> Which should be:
> %{__python} setup.py install -O1 --skip-build --root %{buildroot}
> 
> even though the first is given as an example in the documentation.

Using the first variant is completely legal. The consistency here means that $RPM_BUILD_ROOT and %{buildroot} should not be mixed inside one spec file.

> Summary - MINOR issues with use of macros in spec file.
> 
> I am curious though as to why the example server isn't included in either the
> same package, or in a documentation package. I would expect to see it in
> /usr/share/pywebdav-0.8. I really think this would be a worthwhile addition.

There are few reasons why not include the server by default:
- the server is not installed by the upstream setup utility
- I have a package that will use only the library
- distributing a network server has a broader consequences (security, etc.)
So until there is a real demand for this server I don't have an intent to package it.
Comment 3 David Carter 2009-01-10 10:48:43 EST
You are correct about the macros. Sorry, but I mis-read the documentation. That's why I'm still at the practice review stage :)

As for the server, I'm not suggesting you install it in the Python libraries, but in the share section where people may refer to it as an example, perhaps as part of a documentation package. This would greatly help people who've never used the package before, and is no more dangerous than distributing any example source code. My preference would be to see it, but I understand why you haven't included it here. Just keep it in mind.
Comment 4 Ignacio Vazquez-Abrams 2009-01-20 05:21:49 EST
I'm going to second David's idea of including the server (made non-executable) in %doc, but I otherwise approve this package.
Comment 5 Dan Horák 2009-01-20 06:13:39 EST
I am convinced now, I will put the server as an example into %doc. Thanks for the review.
Comment 6 Dan Horák 2009-01-20 06:15:13 EST
New Package CVS Request
=======================
Package Name: pywebdav
Short Description: WebDAV library for Python
Owners: sharkcz
Branches: F-9 F-10 EL-5
Comment 7 Kevin Fenzi 2009-01-20 16:07:35 EST
cvs done.
Comment 8 Dan Horák 2009-01-21 03:18:44 EST
imported and built

Note You need to log in before you can comment on or make changes to this bug.